//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_color5 DeepSkyBlue
#property indicator_color6 PaleVioletRed
#property indicator_color7 DeepSkyBlue
#property indicator_color8 PaleVioletRed
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT
#property indicator_style8 STYLE_DOT

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    degree           = 3;
extern double deviations       = 1.5;
extern int    bars             = 250;
extern int    futureBars       = 50;
extern int    calculatingMode  = 0;
extern bool   Interpolate      = true;

//
//
//
//
//

double regh[],regl[],chnh[],chnl[];
double reghf[],reglf[],chnhf[],chnlf[];

string indicatorFileName;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   futureBars = MathMax(MathMin(bars,futureBars),0);
      SetIndexBuffer(0, regh);
      SetIndexBuffer(1, regl);
      SetIndexBuffer(2, chnh);
      SetIndexBuffer(3, chnl);
      SetIndexBuffer(4, reghf);
      SetIndexBuffer(5, reglf);
      SetIndexBuffer(6, chnhf);
      SetIndexBuffer(7, chnlf);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue";   if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
            SetIndexShift(4,futureBars*timeFrame/Period());
            SetIndexShift(5,futureBars*timeFrame/Period());
            SetIndexShift(6,futureBars*timeFrame/Period());
            SetIndexShift(7,futureBars*timeFrame/Period());
      
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(timeFrame)+" Regression channel");
  return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double a[20,20],b[20],c[20],x[20],y[20],s[40];

int start()
{
   if (calculateValue || timeFrame==Period())
   {
      int i,k,n; double sum,sumh,suml;
      int d = degree+1; s[1] = bars+1;

      for(k=1; k<=d*2-2; k++) { sum=0; for(n=0; n<=bars; n++) sum += MathPow(n,k); s[k+1] = sum; }
               switch(calculatingMode)
               {
                     case 1 : for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += High[n] *MathPow(n,k-1); b[k] = sum; }
                              for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Low[n]  *MathPow(n,k-1); c[k] = sum; } break;
                     default: for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Close[n]*MathPow(n,k-1); b[k] = sum; c[k] = sum; }
               }
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, b, x)) return(0);
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, c, y)) return(0);
      for(k=bars; k>=-futureBars; k--)
      {
            for(i=1,sumh=0,suml=0; i<=degree; i++) { sumh+=x[i+1]*MathPow(k,i); suml+=y[i+1]*MathPow(k,i); }
               if (k<=0) { reghf[k+futureBars] = x[1]+sumh; reglf[k+futureBars] = y[1]+suml; }
               if (k>=0) { regh[k]             = x[1]+sumh; regl[k]             = y[1]+suml; }
      }  
      
      //
      //
      //
      //
      //
      
      double devh = 0; 
      double devl = 0; 
         for(k=0; k<=bars; k++)
               switch(calculatingMode)
               {
                  case 1 :
                  case 2 : devh += MathPow(High[k] -regh[k],2); 
                           devl += MathPow(Low[k]  -regl[k],2); break;
                  default: devh += MathPow(Close[k]-regh[k],2); 
                           devl = devh;
               }               
         devh = MathSqrt(devh/(bars+1))*deviations;
         devl = MathSqrt(devl/(bars+1))*deviations;
             
         //
         //
         //
         //
         //
                      
         for(k=0; k<=bars; k++)
         {
            chnh[k]=regh[k]+devh;
            chnl[k]=regl[k]-devl;
            if (k<=futureBars)
            {
               chnhf[k]=reghf[k]+devh;
               chnlf[k]=reglf[k]-devl;
            }
         }

      //
      //
      //
      //
      //

      if (!calculateValue)
      {   
         SetIndexDrawBegin(0, Bars-bars-1);
         SetIndexDrawBegin(1, Bars-bars-1);
         SetIndexDrawBegin(2, Bars-bars-1); 
         SetIndexDrawBegin(3, Bars-bars-1); 
         SetIndexDrawBegin(4, Bars-futureBars-1); 
         SetIndexDrawBegin(5, Bars-futureBars-1); 
         SetIndexDrawBegin(6, Bars-futureBars-1); 
         SetIndexDrawBegin(7, Bars-futureBars-1); 
      }         
      return(0);
   }
   
   //
   //
   //
   //
   //
   //
 
   for(i=MathMin(MathMax(bars,futureBars)*timeFrame/Period(),Bars-1); i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      if (y<=bars)
      {
         regh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,0,y);
         regl[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,1,y);
         chnh[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,2,y);
         chnl[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,3,y);
      }
      if (y<=futureBars)
      {
         reghf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,4,y);
         reglf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,5,y);
         chnhf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,6,y);
         chnlf[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",degree,deviations,bars,futureBars,calculatingMode,7,y);
      }
      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      
      //
      //
      //
      //
      //
      
      if (y<=bars)
      {
         interpolate(regh ,iTime(NULL,timeFrame,y),i);
         interpolate(regl ,iTime(NULL,timeFrame,y),i);
         interpolate(chnh ,iTime(NULL,timeFrame,y),i);
         interpolate(chnl ,iTime(NULL,timeFrame,y),i);
      }         
      if (y<=futureBars)
      {
         interpolate(reghf,iTime(NULL,timeFrame,y),i);
         interpolate(reglf,iTime(NULL,timeFrame,y),i);
         interpolate(chnhf,iTime(NULL,timeFrame,y),i);
         interpolate(chnlf,iTime(NULL,timeFrame,y),i);
      }         
   }

   //
   //
   //
   //
   //
   
         SetIndexDrawBegin(0, Bars-bars*timeFrame/Period()-1);
         SetIndexDrawBegin(1, Bars-bars*timeFrame/Period()-1);
         SetIndexDrawBegin(2, Bars-bars*timeFrame/Period()-1); 
         SetIndexDrawBegin(3, Bars-bars*timeFrame/Period()-1); 
         SetIndexDrawBegin(4, Bars-futureBars*timeFrame/Period()-1); 
         SetIndexDrawBegin(5, Bars-futureBars*timeFrame/Period()-1); 
         SetIndexDrawBegin(6, Bars-futureBars*timeFrame/Period()-1); 
         SetIndexDrawBegin(7, Bars-futureBars*timeFrame/Period()-1); 
   return(0);   
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool iCalc(int n, double& a[][],double& b[], double& x[]) 
{
   int i,j,k; double t,q;

   for(k = 1; k <=n-1; k++) 
   {
      int    l = 0; 
      double m = 0; 
         for(i=k; i<=n; i++) 
            if (MathAbs(a[i,k]) > m) { m = MathAbs(a[i,k]); l = i; } 
            if (l==0) return(false);   

            //
            //
            //
            
            if(l != k) 
            {
               for(j=1; j<=n; j++) { t = a[k,j]; a[k,j] = a[l,j]; a[l,j] = t; } 
                                     t = b[k];   b[k]   = b[l];   b[l]   = t;
            }  
            for(i=k+1; i<=n; i++) 
            {
               q = a[i,k]/a[k,k]; 
                  for(j=1; j<=n; j++) 
                    if (j == k)
                           a[i,j] = 0; 
                    else   a[i,j] = a[i,j] - q*a[k,j];
               b[i] = b[i] - q*b[k];
            }
   }
   
   //
   //
   //
   //
   //
   
      x[n] = b[n] / a[n,n]; 
      for(i=n-1; i>=1; i--) 
      {
         t = 0;  
         for(j = 1; j <= n - i; j++) 
         { 
            t    += a[i,i+j]*x[i+j]; 
            x[i] = (1.0/a[i,i])*(b[i]-t);
         }
      }
   return(true);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}